/*
/*
Scrivere un programma per la gestione delle informazioni relative alle operazioni relative ad una banca.
La banca ha 3 sportelli, uno per ogni tipo di operazione. Ogni sportello ha una propria coda di clienti.
I clienti sono caratterizzati dalle seguenti informazioni: nome, codice fiscale, tipo di operazione.
Nel momento in cui un cliente viene servito, vengono conservate in un vettore di 3 liste, una per ogni tipo di operazione, le seguenti informazioni relative alloperazione appena eseguita: codice fiscale, importo delloperazione, data delloperazione, tipo operazione.
Nel programma  presente un men caratterizzato dalle seguenti funzioni:
1) Inserimento in coda di un nuovo cliente;
2) Visualizzazione dei clienti di una certa coda;
3) Servizio del primo elemento della coda e inserimento delloperazione appena eseguita nella lista relativa al tipo di operazione;
4) Visualizzazione del numero di operazioni gi eseguite relative a una certa data;
5) Salvataggio su file delle code
6) Lettura da file dei clienti e inserimento in coda 
Liberare la memoria allocata dinamicamente.
*/

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct {
        char codfisc[17];
        char nome[80];
        int sesso, tipo; 
        }cliente;

typedef struct {
        char codfisc[17];
        float importo;
        char data[12];
        int tipo;
        } operazione;
        
struct atomocoda {
       cliente dato;
       struct atomocoda *next;
       };

typedef struct {
        struct atomocoda *primo,*ultimo;
        } coda;
        
struct lista { 
       operazione dato;
       struct lista *next;
       };
       
void leggi(cliente *c);
void in_coda(coda Q[3], cliente c);
void visualizza(coda Q[3]);
void in_lista(struct lista **tl, operazione op);
void out_coda(coda *Q);
void conta_operazioni(struct lista *L[3]);
void salva(coda Q[3]);
void leggi_file(coda Q[3]);

main() {
       struct lista *L[3],*a;
       coda Q[3];
       cliente cl;
       operazione op;
       int i,scelta;
       
       /* inizializzazione*/
       for(i=0;i<3;i++)
         { L[i]=NULL;
           Q[i].primo=NULL;
           Q[i].ultimo=NULL;
         }
         
       do {
           printf("Scegli.\n");
           printf("1. Ins.cliente\n2. Vis. coda\n");
           printf("3. Servi coda\n4. Visualizza numero operaz.\n");
           printf("5. Salva clienti\n6. Carica clienti da file\n");
           printf("0. fine\n");
           scanf("%d",&scelta);
           switch(scelta) {
           case 1:  leggi(&cl);
                    in_coda(Q,cl);
                    break;
           case 2:  visualizza(Q);
                    break;
           case 3:  printf("Quale coda servire ?\n");
                    scanf("%d",&i);
                    if(Q[i].primo!=NULL)
                    /* se la coda non e' vuota */
                    {
                      cl=Q[i].primo->dato;
                      op.tipo=cl.tipo;
                      strcpy(op.codfisc,cl.codfisc);
                      printf("Importo: ");
                      scanf("%f",&op.importo);
                      printf("Data :");
                      scanf("%s",op.data);
                      
                      in_lista(&L[op.tipo],op);
                      out_coda(&Q[i]);
                    }
                    else printf("Coda vuota\n"); 
                    break;
           case 4: conta_operazioni(L);
                   break;
           case 5: salva(Q);
                   break;
           case 6: leggi_file(Q);
                   break;
           default:; }
           } while(scelta!=0);
           
           for(i=0;i<3;i++)
             while(Q[i].primo!=NULL)
               out_coda(&Q[i]);
               
           for(i=0;i<3;i++)
              while(L[i]!=0)
                { a=L[i];
                  L[i]=a->next;
                  free(a);
                }
}
           
       
void leggi(cliente *c)
{
     printf("Cod. fiscale: ");
     scanf("%s",c->codfisc);
     printf("Nome: ");
     scanf("%s",c->nome);
     printf("Sesso (0=M, 1=F) ");
     scanf("%d",&c->sesso);
     printf("tipo operazione (0..2) ");
     scanf("%d",&c->tipo);
}

void in_coda(coda Q[3], cliente c)
{
     struct atomocoda *a;
     
     a=(struct atomocoda *) malloc(sizeof(struct atomocoda));
     if(a==NULL) return;
     a->dato=c;
     a->next=NULL;
     if(Q[c.tipo].primo==NULL)
        Q[c.tipo].primo=a;
     else Q[c.tipo].ultimo->next=a;
     Q[c.tipo].ultimo=a;
}
     
         
void visualizza(coda Q[3])
{ int i,s;
 
  struct atomocoda *a;
 
    printf("Quale coda ? (0..2) ");
    scanf("%d",&i);
    printf("Sesso (0=M, 1=F) ");
    scanf("%d",&s);
    a=Q[i].primo;
    while(a!=NULL) 
    /* fino a quando non arriviamo alla fine della coda*/
     { if(a->dato.sesso==s)
           printf("Cod. fiscale: %s\n",a->dato.codfisc);
        
       a=a->next;
     } 
       
}    

void in_lista(struct lista **tl, operazione op)
{
     struct lista *a;
     
     a=(struct lista *) malloc(sizeof(struct lista));
     if(a==NULL) return;
     a->dato=op;
     a->next=*tl;
     *tl=a;
}
     
void out_coda(coda *Q)
{  /* invocata solo se la coda non e' vuota*/
     struct atomocoda *a;
     
     a=Q->primo;
     Q->primo=a->next;
     free(a);
     if(Q->primo==NULL)
       Q->ultimo=NULL;
}
     
void conta_operazioni(struct lista *L[3])
{
     char data[12];
     struct lista *a;
     int i,conta;
     
     printf("Data: ");
     scanf("%s",data);
     
     conta=0;
     for(i=0;i<3;i++)
      { a=L[i];
        while(a!=NULL)
          { if(strcmp(a->dato.data,data)==0)
              conta++;
            a=a->next;
          }
      }
      
      printf("Il numero di elementi con data %s e' %d\n", data, conta);
}  
     
     
void salva(coda Q[3])
{
     FILE *p;
     int i;
     struct atomocoda *a;
     cliente c;
     
     p=fopen("cliente.cl", "w");
     if(p) {
            for(i=0;i<3;i++)
             { a=Q[i].primo;
               while(a!=NULL)
                {   c=a->dato;
                    fwrite(&c,sizeof(cliente),1,p);
                    a=a->next;
                }
             }
             fclose(p);
            }
}
     
void leggi_file(coda Q[3])
{
     FILE *p;
     cliente c;
     
     p=fopen("cliente.cl","r");
     if(p) {
             while(fread(&c,sizeof(cliente),1,p)!=0)
               { 
                 in_coda(Q,c);
                 }
             fclose(p);
           }
     }
